/*
  CPP_CONTEST=2013
  CPP_PROBLEM=C
  CPP_LANG=CUDA
  CPP_PROCESSES_PER_NODE=mercurio 1
*/

/* RECORD
Juan Mompeán Esteban
students of the University of Murcia, Spain
In the warm-up for the IV Spanish Parallel Programming Contest
time 4199 msec
speed-up 7.03
*/ 

/*The first CUDA solution for the problem.
It surpasses the OpenMP solution, but not that with MPI+OpenMP*/

#include <stdlib.h>
#include <stdio.h>
#include <helper_functions.h>
#include <helper_cuda.h>
 

__global__ void accumulatelocal(int *a,int N, int v,int r1,int c1,int r2,int c2)
{
  int x = blockIdx.x * blockDim.x + threadIdx.x + r1;
  int y = blockIdx.y * blockDim.y + threadIdx.y + c1;

  if (x > r2 || y > c2) {
    return;
  }
  a[x * N + y] += v;
}

    
void  sec(int N,int M,int *a,int *value,int *r1,int *c1,int *r2,int *c2)
{
  int *d_a;
  cudaMalloc(&d_a, sizeof(int) * N * N);
  cudaMemcpy(d_a, a, sizeof(int) * N * N, cudaMemcpyHostToDevice);

  for (int k = 0; k < M; k++) {
    dim3 block(1, 256, 1);
    dim3 grid(ceil((r2[k] - r1[k] + 1) / (float)block.x), ceil((c2[k] - c1[k] + 1) / (float)block.y), 1);
    accumulatelocal<<<grid, block>>>(d_a, N, value[k], r1[k], c1[k], r2[k], c2[k]);
  }

  cudaMemcpy(a, d_a, sizeof(int) * N * N, cudaMemcpyDeviceToHost);
  cudaFree(d_a);
}

